<template>
  <div class="login-page">
    <div class="module">
      <div class="left">
        <img class="logo" src="../../assets/logo.png" alt="">
        <p class="p1">算法竞赛开赛</p>
        <p class="p2">提醒聚合站</p>
        <a-divider/>
        <p class="description">为用户提供订阅、推荐及推送提醒服务。通过平台，让算法竞赛爱好者们可以更加快速、便捷、及时地获知各种竞赛的消息。</p>
      </div>
      <div class="right">
        <div class="title">
          <span>登录</span>
          <p>没有账号？<span @click="toRegister">点此注册</span></p>
        </div>
        <div class="form">
          <a-form-model ref="form" :model="formData" :rules="formRules">
            <a-form-model-item>
              <p v-if="errorInfo" class="error">{{errorInfo}}</p>
            </a-form-model-item>
            <a-form-model-item prop="username">
              <a-input v-model="formData.username" size="large" placeholder="用户名" @pressEnter="checklogin">
                <a-icon slot="prefix" type="user" style="color:#517E55"/>
              </a-input>
            </a-form-model-item>
            <a-form-model-item prop="password">
              <a-input v-model="formData.password" size="large" type="password" placeholder="密码"
                       @pressEnter="checklogin">
                <a-icon slot="prefix" type="lock" style="color:#517E55"/>
              </a-input>
            </a-form-model-item>
            <a-form-model-item>
              <p class="forgot-pwd"><a @click="toResetpw">忘记密码</a></p>
            </a-form-model-item>
            <a-form-model-item>
              <a-button size="large" block type="primary" @click="checklogin">登 录</a-button>
            </a-form-model-item>
          </a-form-model>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import global_ from '../../components/Global'
import Bus from '../../bus.js'

export default {
  data() {
    return {
      username: '',
      password: "",
      token: '',
      count: "",
      errorLogin: false,
      errorInfo: '',
      formData: {
        username: '',
        password: "",
      },
      formRules: {
        username: [{required: true, message: '用户名为必填项', trigger: 'blur'}],
        password: [{required: true, message: '密码为必填项', trigger: 'blur'}]
      }
    };
  },
  created: function () {
    document.title = this.$route.meta.title || this.$route.meta.pathName
  },
  watch: {
    $route() {
      document.title = this.$route.meta.title || this.$route.meta.pathName
    },
  },
  methods: {
    toResetpw() {
      this.$router.push({path: "/forgetPassword"});
    },
    toRegister() {
      this.$router.push({path: "/register"});
    },
    changeCurrent() {
      Bus.$emit('current', 'index')
    },
    toIndex() {
      this.$router.push({path: "/"});
    },
    checklogin() {
      this.$refs.form.validate(valid => {
        if (valid) {
          this.$axios.post('login', {
            name: this.formData.username,
            password: this.formData.password,
          }).then((res) => {
            if (res.code == 0) {
              this.$store.state.user.user_info.username = this.formData.username;
              sessionStorage.user_name = this.formData.username
              global_.token = res.token;
              global_.loginStatus = true;
              sessionStorage.setItem('token', res.result.token);
              sessionStorage.setItem('userName', this.formData.username);
              sessionStorage.setItem('loginStatus', true);
              this.errorInfo = ''
              this.startDivi();
            } else if (res.code == 1) {
              this.errorInfo = '用户名不存在！'
            } else if (res.code == 2) {
              this.errorInfo = '密码错误！'
            } else if (res.code == 3) {
              this.errorInfo = '用户被封禁！'
            } else {
              this.errorInfo = '登录失败！'
            }
          }).catch(() => {
            this.errorInfo = '登录失败！'
          })
        }
      })
    },
    changeErrorLogin() {
      this.errorLogin = true;
    },
    startDivi() {
      const TIME_COUNT = 2;
      const hide = this.$message.loading('登录成功！即将返回首页！', 0);
      setTimeout(hide, 2500);
      if (!this.timer) {
        this.count = TIME_COUNT;
        this.show = false;
        this.timer = setInterval(() => {
          if (this.count > 0 && this.count <= TIME_COUNT) {
            this.count--;
          } else {
            this.show = true;
            clearInterval(this.timer);
            this.timer = null;
            this.changeCurrent();
            this.$router.push({
              path: '/'
            });

          }
        }, 1000)
      }

    },
  }
}
</script>

<style lang="less" scoped>
.login-page {
  height: 100%;
  background-image: url("../../assets/login_back.jpeg");
  background-repeat: no-repeat;
  background-size: cover;

  .module {
    position: fixed;
    top: 12%;
    left: 50%;
    transform: translateX(-50%);
    display: flex;

    .left {
      width: 400px;
      background: #517E55;
      padding: 30px 60px;
      box-sizing: border-box;

      .logo {
        transform: scale(1.2);
        display: block;
        margin: 20px auto 30px auto;
      }

      p {
        font-size: 25px;
        font-weight: bold;
        color: #ffffff;
        &.p2 {
          text-align: right;
        }
      }

      .description {
        font-size: 14px;
        font-weight: normal;
        margin-top: 40px;
        line-height: 24px;
      }
    }

    .right {
      width: 400px;
      background: #ffffff;
      padding: 25px 60px;
      box-sizing: border-box;

      .title {
        display: flex;
        align-items: baseline;
        justify-content: space-between;

        > span {
          font-size: 25px;
          font-weight: bold;
        }

        p {
          span {
            color: #517E55;
            cursor: pointer;
          }
        }
      }

      .form {
        .error {
          margin-bottom: 0;
          background: rgba(255, 0, 0, .1);
          height: 32px;
          line-height: 32px;
          border: 1px solid rgba(255, 0, 0, .5);
          border-radius: 4px;
          padding-left: 10px;
          color: #9F3A38;
        }

        .forgot-pwd {
          text-align: right;
        }
      }
    }
  }
}
</style>